#include "Solution.h"
#include <algorithm>        // sortʹ
#include <map>
#include <unordered_set>

int Solution::singleNumber(vector<int>& nums) {
    int data = 0;
    for (int i = 0; i < nums.size(); i++) {
        data ^= nums[i];
    }
    return data;
}

int Solution::majorityElement(vector<int>& nums) {
#if Ӧʵַ == 1
    // 1ȡмֵΧһ룬мֵ϶
    sort(nums.begin(), nums.end());
    return nums[nums.size() / 2];
#elif Ӧʵַ == 2
    map<int, int> counts;
    int length = nums.size();
    for (int i = 0; i < length; i++) {
        int count = ++counts[nums[i]];
        //ĳֳֵĸѾһ룬Լ
        if (count > length / 2)
            return nums[i];
    }
    return -1;
#elif Ӧʵַ == 3
    for (int i = nums.size() - 1; i > 0; i--) {
        int max = nums.size() - 1;
        if (nums[i] != nums[i - 1]) {
            nums.erase(nums.begin() + i);
            nums.erase(nums.begin() + i - 1);
            if (i == max)
                i--;
        }
    }
    return nums[0];
#endif
}

bool Solution::searchMatrix(vector<vector<int>>& matrix, int target) {
    int col = 0, row = matrix.size() - 1;
    while (row >= 0 && col < matrix[0].size()) {
        if (target > matrix[row][col]) {
            col++;
        }
        else if (target < matrix[row][col]) {
            row--;
        }
        else {
            return true;
        }
    }
    return false;
}

void Solution::merge(vector<int>& nums1, int m, vector<int>& nums2, int n)
{
    int offset = m + n - 1;
    m--;
    n--;
    while (m >= 0 || n >= 0)
    {
        if (n >= 0 && (m < 0 || nums2[n] > nums1[m])) {
            nums1[offset] = nums2[n];
            n--; 
        }
        else {
            nums1[offset] = nums1[m];
            m--;
        }
        offset--;
    }
}

int Solution::superEggDrop(int k, int n) {
    return 0;
}

vector<int> Solution::plusOne(vector<int>& digits) {
    bool add = false;
    digits[digits.size() - 1]++;
    for (int i = digits.size() - 1; i >= 0; i--) {
        if (add)
            digits[i]++;
        add = false;
        if (digits[i] == 10) {
            digits[i] = 0;
            add = true;
        }
    }
    if (add)
    {
        digits.insert(digits.begin(), 1);
    }
    return digits;
}

bool Solution::isPalindrome(string s) {
    if (s.length() <= 0)
        return true;
    int offset = (int)'A' - (int)'a';
    vector<char> vec;
    for (int i = 0; i < s.length(); i++) {
        if (s[i] >= 'A' && s[i] <= 'Z')
            vec.push_back(s[i] - offset);
        else if (s[i] >= 'a' && s[i] <= 'z')
            vec.push_back(s[i]);
        else if (s[i] >= '0' && s[i] <= '9')
            vec.push_back(s[i]);
    }
    if (vec.size() <= 0)
        return true;
    for (int i = 0; i < vec.size() / 2 + 1; i++) {
        if (vec[i] != vec[vec.size() - i - 1])
            return false;
    }
    return true;
}

int Solution::minSubArrayLen(int target, vector<int>& nums) {
    int start = 0;
    int count = 0;
    int min = INT32_MAX;
    for (int i = 0; i < nums.size(); i++) {
        count += nums[i];
        while (count >= target && start < i) {
            int offset = i - start + 1;
            if (min > offset)
                min = offset;
            count -= nums[start];
            start++;
        }
    }
    if (min != INT32_MAX)
        return min;
    return 0;
}

int m_totalLen;
void GetAllSet(vector<string> words, unordered_set<string>& mySet, string str) {
    string last = str;
    for (int i = 0; i < words.size(); i++) {
        str = last + words[i];
        vector<string> vec(words);
        vec.erase(vec.begin() + i);
        GetAllSet(vec, mySet, str);
    }
    if (str != "" && str.length() == m_totalLen) {
        mySet.insert(str);
    }
}
vector<int> Solution::findSubstring(string s, vector<string>& words) {
    m_totalLen = words[0].length() * words.size();
    unordered_set<string> mySet;
    GetAllSet(words, mySet, "");

    vector<int> vec;
    for (auto str : mySet) {
        size_t pos = s.find(str);
        while (pos != string::npos)
        {
            vec.push_back(pos);
            pos = s.find(str, pos + 1);
        }
    }
    return vec;
}

string Solution::minWindow(string s, string t) {
    map<char, int> myMap;
    map<char, int> lead;
    for (int i = 0; i < t.length(); i++) {
        lead[t[i]]++;
    }
    int len = INT32_MAX;
    int start = 0;
    int minStart = -1;
    for (int i = 0; i < s.length(); i++) {
        myMap[s[i]]++;
        while (start <= i) {
            bool ok = true;
            for (const auto& pair : lead) {
                // std::cout << pair.first << ": " << pair.second << std::endl;
                if (myMap[pair.first] < pair.second) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                myMap[s[start]]--;
                int cuLen = i - start + 1;
                if (cuLen < len) {
                    len = cuLen;
                    minStart = start;
                }
                start++;
            }
            else {
                break;
            }
        }
    }
    return minStart == -1 ? "" : s.substr(minStart, len);
}

vector<string> Solution::summaryRanges(vector<int>& nums) {
#if ҵе⣬ǲ
    int start = 0;
    vector<string> vec;
    if (nums.size() == 0)
        return vec;
    for (int i = 1; i < nums.size(); i++) {
        if (nums[i] - nums[i - 1] != 1) {
            if (start != i - 1)
                vec.push_back(to_string(nums[start]) + "->" + to_string(nums[i - 1]));
            else
                vec.push_back(to_string(nums[start]));

            start = i;
        }
    }
    if (start != nums.size() - 1)
        vec.push_back(to_string(nums[start]) + "->" + to_string(nums[nums.size() - 1]));
    else
        vec.push_back(to_string(nums[start]));
    return vec;
#else
    vector<string> ret;
    int i = 0;
    int n = nums.size();
    while (i < n) {
        int low = i;
        i++;
        while (i < n && nums[i] == nums[i - 1] + 1) {
            i++;
        }
        int high = i - 1;
        string temp = to_string(nums[low]);
        if (low < high) {
            temp.append("->");
            temp.append(to_string(nums[high]));
        }
        ret.push_back(move(temp));
    }
    return ret;
#endif
}

vector<vector<int>> Solution::insert(vector<vector<int>>& intervals, vector<int>& newInterval) {
    int start = -1;
    int end = -1;
    for (int i = 0; i < intervals.size(); i++) {
        if (start >= 0) {
            // жλã־ͽ
            // newĺֵȵǰһСǰĺϲ
            if (newInterval[1] < intervals[i][0]) {
                end = i - 1;
                if (intervals[start][1] < newInterval[1])
                    intervals[start][1] = newInterval[1];
                break;
            }
            // newĺֵȵڶС
            if (newInterval[1] == intervals[i][0] || newInterval[1] <= intervals[i][1]) {
                end = i;
                intervals[start][1] = intervals[end][1];
                break;
            }
        }
        else if (intervals[i][1] >= newInterval[0]) {
            if (intervals[i][0] > newInterval[1])
            {
                intervals.insert(intervals.begin() + i, newInterval);
                start = 0;
                end = 0;
                break;
            }
            if (intervals[i][0] > newInterval[0])
                intervals[i][0] = newInterval[0];
            start = i;
        }
    }

    // ûҵԭΪ
    if (start == -1) {
        intervals.push_back(newInterval);
    }
    // endû£˵һendС涼Ҫ滻
    else if (start >= 0 && end == -1)
    {
        end = intervals.size() - 1;
        if (intervals[end][1] > newInterval[1])
            newInterval[1] = intervals[end][1];
        intervals[start][1] = newInterval[1];
    }
    // start+1endȫɾ
    for (int i = end; i > start; i--) {
        intervals.erase(intervals.begin() + i);
    }
    return intervals;
}

int Solution::minimumNumbers(int num, int k) {
    if (num == 0)
        return 0;
    if (num == k)
        return 1;
    if (k == 0)
    {
        if (num >= 10 && num % 10 == 0)
            return 1;
        else
            return -1;
    }

    int value = 0;
    for (int i = 1; i <= 10; i++) {
        value += k;
        if ((value % 10) == (num % 10) && value <= num)
            return i;
    }
    return -1;
}