#include "ͼ.h"
#include <queue>
#include <set>
#include <map>
#include <unordered_map>

class position {
public:
	char X;
	char Y;
	position(int x, int y):X(x), Y(y){}
};
bool numsIslandsBfs(vector<vector<char>>& grid, int x, int y) {
	queue<position> q;
	if (grid[y][x] == 0)
		return false;
	int width = grid[0].size();
	int height = grid.size();
	q.push(position(x, y));
	grid[y][x] = 0;
	while (q.size() > 0) {
		position p = q.front();
		x = p.X;
		y = p.Y;
		if (x - 1 >= 0 && grid[y][x - 1]) {
			q.push(position(x - 1, y));
			grid[y][x - 1] = 0;
		}
		if (x + 1 < width && grid[y][x + 1]) {
			q.push(position(x + 1, y));
			grid[y][x + 1] = 0;
		}
		if (y - 1 >= 0 && grid[y - 1][x]) {
			q.push(position(x, y - 1));
			grid[y - 1][x] = 0;
		}
		if (y + 1 < height && grid[y + 1][x]) {
			q.push(position(x, y + 1));
			grid[y + 1][x] = 0;
		}
		q.pop();
	}
	return true;
}
void dfs(vector<vector<char>>& grid, vector<vector<bool>>& visited, int r, int c) {
	int nr = grid.size(), nc = grid[0].size();
	if (r < 0 || r >= nr || c < 0 || c >= nc || grid[r][c] == '0' || visited[r][c]) return;
	visited[r][c] = true;
	dfs(grid, visited, r - 1, c);
	dfs(grid, visited, r + 1, c);
	dfs(grid, visited, r, c - 1);
	dfs(grid, visited, r, c + 1);
}

int ͼ::numIslands(vector<vector<char>>& grid) {
	int total = 0;
# ifdef 
	for (int i = 0; i < grid[0].size(); i++) {
		for (int j = 0; j < grid.size(); j++) {
			if (numsIslandsBfs(grid, i, j))
				total++;
		}
	}
#else
	// 
	int nr = grid.size();
	if (!nr) return 0;
	int nc = grid[0].size();
	vector<vector<bool>> visited(nr, vector<bool>(nc, false));
	for (int i = 0; i < nr; i++) {
		for (int j = 0; j < nc; j++) {
			if (grid[i][j] == '0' || visited[i][j]) continue;
			total++;
			dfs(grid, visited, i, j);
		}
	}
	return total;
#endif
	return total;
}

bool solveDfs(vector<vector<char>>& board, vector<vector<bool>>& visited, int i, int j) {
	if (visited[i][j])
		return false;
	int nr = board.size(), nc = board[0].size();
	if (i == 0 || j == 0 || i == nr - 1 || j == nc - 1) {
		if (board[i][j] == 'O')
			return true;
		else
			return false;
	}
	if (board[i][j] == 'X')
		return false;
	visited[i][j] = true;
	if (solveDfs(board, visited, i - 1, j) ||
		solveDfs(board, visited, i + 1, j) ||
		solveDfs(board, visited, i, j - 1) ||
		solveDfs(board, visited, i, j + 1))
		return true;
	return false;
}
void solveDfsChange(vector<vector<char>>& board, vector<vector<bool>>& visited, int i, int j) {
	int nr = board.size(), nc = board[0].size();
	if (i < 0 || j < 0 || i >= nr || j >= nc || visited[i][j] || board[i][j] == 'X')
		return;
	board[i][j] =  'X';
	visited[i][j] = true;
	solveDfsChange(board, visited, i - 1, j);
	solveDfsChange(board, visited, i + 1, j);
	solveDfsChange(board, visited, i, j - 1);
	solveDfsChange(board, visited, i, j + 1);
}
// ֲһǱݺvector<vector<char>> backup(board);һȫص
void ͼ::solve(vector<vector<char>>& board) {
	int nr = board.size(), nc = board[0].size();
	vector<vector<bool>> visited(nr, vector<bool>(nc, false));
	vector<vector<bool>> visited1(nr, vector<bool>(nc, false));
	for (int i = 1; i < board.size() - 1; i++) {
		for (int j = 1; j < board[0].size() - 1; j++) {
			if (board[i][j] == 'O' && !solveDfs(board, visited, i, j)) {
				// ڲⲿֶ滻
				solveDfsChange(board, visited1, i, j);
			}
		}
	}
}

unordered_map<Node*, Node*> visited;
Node* ͼ::cloneGraph(Node* node) {
	if (node == nullptr)
		return node;

	// ýڵ㱻ʹֱӴӹϣȡ
	if (visited.find(node) != visited.end())
		return visited[node];

	Node* cloneNode = new Node(node->val);
	visited[node] = cloneNode;

	// нڵھ,
	for (auto& neighbor : node->neighbors) {
		cloneNode->neighbors.emplace_back(cloneGraph(neighbor));
	}
	return cloneNode;
}